class Polynomial:
    
    " Class representing a polynom P(x) -> c_0 + c_1*x + c_2*x^2 + ..."
    
    def __init__(self, coeffs):
        self.coeffs = coeffs
        
    def __call__(self, x):
        return sum([coef*x**exp for exp, coef in enumerate(self.coeffs)])
    
    def diff(self, n):
        coeffs = self.coeffs
        for k in range(n):
            coeffs = [i * coeffs[i] for i in range(1, len(coeffs))]
        return Polynomial(coeffs)
    
    def __repr__(self): 
        out = ""
        pf = "d"
        for k, c in enumerate(self.coeffs):
            if c != 0:
                if c == 1:
                    val = "+" if k != 0 else "+1"
                elif c == -1:
                    val = "-" if k != 0 else "-1"
                else:
                    val = f"{c:{pf}}"
                    
                if k == 0:
                    out += val
                elif k == 1:
                    out += val + "X"
                else:
                    out += val + f"X^{k}"
                
                pf = "+d"
                
        return out