import math

def is_prime(n):
    bound = math.floor(math.sqrt(n))
    for i in range(2, bound + 1):
        if n % i == 0:
            return False
    return True

# Using decimal <-> str conversion from Python
def get_rotations(n):
    rot = []
    s = str(n)
    for i in range(len(s)):
        rot.append(int(s))
        s = s[1:] + s[0]
    return rot

# Variant using only arithmetics
"""
def get_rotations(n):
    rot = []
    power = math.floor(math.log10(n))
    p10 = 10 ** power
    for i in range(power + 1):
        rot.append(n)
        n = n // 10 + (n % 10) * p10
    return rot
"""

def is_circular_prime(n):
    for i in get_rotations(n):
        if not is_prime(i):
            return False
    return True


N = 1000
cnt = 0
for i in range(2, N):
    if is_circular_prime(i):
        cnt += 1

print(cnt)

