def cipher(txt, key):
    cip = ""
    for letter in txt:
        if letter in alphabet_to_num:
            index = (alphabet_to_num[letter] + key) % 26
            cip += alphabet[index]
        else:
            cip += letter

    return cip

def guess_key(secret):
    # Count occurrence of each letter
    cnt = [0] * 26
    for letter in secret:
        if letter in alphabet_to_num:
            cnt[alphabet_to_num[letter]] += 1

    # Find most frequent letter
    max_index, max_value = -1, -1
    for i in range(26):
        if cnt[i] > max_value:
            max_index = i
            max_value = cnt[i]

    # More concise way
    # max_index = max(enumerate(cnt), key=lambda v: v[1])[0]

    # Guess key if 'e' is the most frequent letter in the input language
    return max_index - alphabet_to_num['e']

def decrypt(secret):
    key = guess_key(secret)
    print(f"Guessed key: {key}")
    print(f"Decrypted text:")
    print(plain(secret, key))

# Plain text used to generate the secrets (from wikipedia page above)
"""
text1 = "Letter frequency is simply the amount of times letters of the alphabet appear on average in written language. Letter frequency analysis dates back to the Arab mathematician Al-Kindi (c. 801–873 AD), who formally developed the method to break ciphers. Letter frequency analysis gained importance in Europe with the development of movable type in 1450 AD, where one must estimate the amount of type required for each letterform. Linguists use letter frequency analysis as a rudimentary technique for language identification, where it's particularly effective as an indication of whether an unknown writing system is alphabetic, syllabic, or ideographic."
text2 = "Accurate average letter frequencies can only be gleaned by analyzing a large amount of representative text. With the availability of modern computing and collections of large text corpora, such calculations are easily made. Examples can be drawn from a variety of sources (press reporting, religious texts, scientific texts and general fiction) and there are differences especially for general fiction with the position of 'h' and 'i', with 'h' becoming more common."
text3 = "Letter frequencies, like word frequencies, tend to vary, both by writer and by subject. One cannot write an essay about x-rays without using frequent Xs, and the essay will have an idiosyncratic letter frequency if the essay is about the use of x-rays to treat zebras in Qatar. Different authors have habits which can be reflected in their use of letters. Hemingway's writing style, for example, is visibly different from Faulkner's. Letter, bigram, trigram, word frequencies, word length, and sentence length can be calculated for specific authors, and used to prove or disprove authorship of texts, even for authors whose styles are not so divergent."
secret = cipher(text1.lower(), 25)
print(secret)
""";
