def find_rooms(lectures):
    # get number of lectures
    N = len(lectures)
    
    # cut the list of time to get start and end
    time = [x.split("-") for x in lectures]
    
    # get start and end time
    starts = [x[0].split(":") for x in time]
    ends =   [x[1].split(":") for x in time]
    
    # convert to minutes
    starts = [int(x[0]) * 60 + int(x[1]) for x in starts]
    ends =   [int(x[0]) * 60 + int(x[1]) for x in ends]
    
    # list of events (start or end of a course)
    events = set(starts + ends) # unique set of events
    
    max_rooms = 0
    curr_rooms = 0
    for e in sorted(events):
        curr_rooms -= sum(1 for t in ends if t == e)
        curr_rooms += sum(1 for t in starts if t == e)
        max_rooms = max(max_rooms, curr_rooms)
         
    return max_rooms  
        
lectures = [ "9:00-10:30", "10:30-11:00" ]
print(find_rooms(lectures)) # Should return 1

lectures = [ "9:00-10:30", "9:30-10:40" ]
print(find_rooms(lectures)) # Should return 2

lectures = [ "9:00-12:00", "9:30-11:30", "10:00-11:00", "11:00-11:45" ]
print(find_rooms(lectures)) # Should return 3

lectures = [ "9:30-10:00", "9:00-10:30", "11:00-12:00", "14:00-18:00", "15:00-16:00", "15:30-17:30", "16:00-18:00"]
print(find_rooms(lectures)) # Should return 3

lectures = [ "9:30-10:00", "9:00-10:30", "11:00-12:00", "14:00-18:00", "15:00-16:15", "15:30-17:30", "16:00-18:00"]
print(find_rooms(lectures)) # Should return 4
