
import numpy as np
import matplotlib.pyplot as plt
import matplotlib.animation as animation

fig = plt.figure()
axis = fig.add_subplot(111, xlim=(-1, 1), ylim=(-0.5, 1.5))

x = np.linspace(-1., 1., 200)
t = np.linspace(0., 10., 100)

pp, = axis.plot(x, np.sinc(t[0]*x))

def update(iframe):
    global pp
    
    pp.set_ydata(np.sinc(t[iframe]*x))
    return pp,

anim = animation.FuncAnimation(fig, update, frames=t.size, interval=10, repeat=True)
plt.show() # Use 'notebook' as matplotlib backend (see first cell) to see the animation
plt.pause(0.001) # Short break to let the backend display the animation

# saving the animation
# Set up formatting for the movie files
Writer = animation.writers['ffmpeg']
writer = Writer(fps=20)
anim.save("sinc_anim.mp4", writer=writer)
