import numpy as np
import matplotlib.pyplot as plt

fig = plt.figure()
axis = fig.add_subplot(111, xlim=(-1, 1), ylim=(-0.5, 1.5))

dt = 1e-2
x = np.linspace(-1., 1., 200)
t = np.linspace(0., 10., 100)

pp, = axis.plot(x, np.sinc(t[0]*x))
plt.pause(dt)
fig.canvas.draw()    # not needed in a script

anim_time = 0.
for anim_time in t[1:]:
    pp.set_ydata(np.sinc(anim_time*x))
    plt.pause(dt)
    fig.canvas.draw()     # not needed in a script
