import numpy as np

# the trapezoidal rule for a function f and a set of points x
def trapz(f, x):
    return np.sum(0.5 * (f(x[:-1]) + f(x[1:])) * (x[1:] - x[:-1]))

# the function f
f = lambda x : np.exp(-x*x)     # works even if x is a scalar

x = np.linspace(-10, 10, 20)
print(trapz(f, x))
print(np.trapz(f(x), x))   # check the result with the function trapz of numpy
